<?php

declare(strict_types=1);

namespace Dedi\SyliusBannerPlugin\Entity;

use Sylius\Component\Resource\Model\ResourceInterface;

interface AlertMessageInterface extends ResourceInterface
{
    public function isEnabled(): bool;

    public function setEnabled(bool $enabled): self;

    public function getStartDateTime(): ?\DateTimeImmutable;

    public function setStartDateTime(?\DateTimeImmutable $startDateTime): self;

    public function getEndDateTime(): ?\DateTimeImmutable;

    public function setEndDateTime(?\DateTimeImmutable $endDateTime): self;

    public function getMessage(): ?string;

    public function setMessage(string $message): self;

    public function getLink(): ?string;

    public function setLink(string $link): self;

    public function getLinkLabel(): ?string;

    public function setLinkLabel(string $linkLabel): self;
}
