<?php

declare(strict_types=1);

namespace Dedi\SyliusBannerPlugin\Repository;

use Sylius\Bundle\ResourceBundle\Doctrine\ORM\EntityRepository;

class AlertMessageRepository extends EntityRepository implements AlertMessageRepositoryInterface
{
    public function getAvailableAlertMessages(\DateTimeImmutable $today): array
    {
        $qb = $this->createQueryBuilder('am');

        return $qb->where('am.enabled = 1')
            ->andWhere('am.isBasketAlert = 0')
            ->andWhere($qb->expr()->orX(
                $qb->expr()->isNull('am.startDateTime'),
                $qb->expr()->lte('am.startDateTime', ':today'),
            ))
            ->andWhere($qb->expr()->orX(
                $qb->expr()->isNull('am.endDateTime'),
                $qb->expr()->gte('am.endDateTime', ':today'),
            ))
            ->setParameter('today', $today)
            ->getQuery()
            ->getResult()
            ;
    }

    public function getAvailableBasketAlertMessages(\DateTimeImmutable $today): array
    {
        $qb = $this->createQueryBuilder('am');

        return $qb->where('am.enabled = 1')
            ->andWhere('am.isBasketAlert = 1')
            ->andWhere($qb->expr()->orX(
                $qb->expr()->isNull('am.startDateTime'),
                $qb->expr()->lte('am.startDateTime', ':today'),
            ))
            ->andWhere($qb->expr()->orX(
                $qb->expr()->isNull('am.endDateTime'),
                $qb->expr()->gte('am.endDateTime', ':today'),
            ))
            ->setParameter('today', $today)
            ->getQuery()
            ->getResult()
            ;
    }
}
